/* global Bdf,CodeMirror */

Bdf.CodeMirrorMode = {};

Bdf.CodeMirrorMode.visibilityListener = function (element, visible) {
    if (visible) {
        Bdf.refreshCodeMirror(element);
    }
};

Bdf.CodeMirrorMode.beforeSerialize = function (form) {
    var $codemirrorTextAreas = Bdf.$(form, {_element: "textarea", codemirrorMode: true});
    for(let i = 0; i < $codemirrorTextAreas.length; i++) {
        let codeMirror = Bdf.getAssociatedCodeMirror($codemirrorTextAreas[i]);
        if (codeMirror) {
            codeMirror.save();
        }
    }
};

$(function () {
    if (Bdf.Deploy) {
        Bdf.Deploy.addVisibilityListener(Bdf.CodeMirrorMode.visibilityListener);
    }
    var $codemirrorTextAreas = Bdf.$({_element: "textarea", codemirrorMode: true});
    for(let i = 0; i < $codemirrorTextAreas.length; i++) {
        let element = $codemirrorTextAreas[i];
        let $element = $(element);
        let mode = $element.data("codemirrorMode");
        let readOnly = false;
        let lineNumbers = false;
        let lineWrapping = true;
        let options = $element.data("codemirrorOptions");
        if (options) {
            for(let option of options.split(" ")) {
                if (option === "numbers") {
                    lineNumbers = true;
                } else if (option === "nowrap") {
                    lineWrapping = false;
                }
            }
        }
        if ($element.attr("disabled")) {
            readOnly = true;
        }
        if (mode) {
            if (mode === 'html') {
                mode = 'xml';
            }
            let codeMirror =  Bdf.toCodeMirror(element, {
                mode: mode,
                lineWrapping: lineWrapping,
                lineNumbers: lineNumbers,
                indentUnit: 4,
                readOnly: readOnly,
                theme: 'bdf',
                extraKeys: {
                    "Tab": false,
                    "Shift-Tab": false
                }
            });
        }
    }
});